﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace desátý
{
    internal interface IGrafickýObjekt: ICloneable
    {
        void nakresli();
    }

    internal class Bod : IGrafickýObjekt
    {
        public Bod(int x, int y, int barva)
        {
            (X, Y, Barva) = (x, y, barva);
        }

        public int X { get; set; }
        public int Y { get; set; }
        public int Barva { get; set; }
        public void nakresli()
        {
            Console.WriteLine($"({X}, {Y})");
        }
        public object Clone()
        {
            return this.MemberwiseClone();
        }
    }

    internal class Obrázek: IGrafickýObjekt
    {
        private List<IGrafickýObjekt> obrázek = new();
        public void Přidej(IGrafickýObjekt objekt)
        {
            obrázek.Add((IGrafickýObjekt)objekt.Clone());
        }
        public void nakresli()
        {
            foreach(var go in obrázek)
            {
                go.nakresli();
            }
        }

        public object Clone()
        {
            Obrázek výsledek = new();
            foreach(var go in this.obrázek)
            {
                výsledek.Přidej(go);
            }
            return výsledek;
        }
    }
}
